Author Topic: Add prefix and suffix to the text or mtext  (Read 996 times)

0 Members and 1 Guest are viewing this topic.

Offline fixo

  • Full Member
  • ***
  • Posts: 135
  • Karma: +4/-0
  • Gender: Male
    • prefered language: C
    • Prog expertise: Good
    • View Profile
Add prefix and suffix to the text or mtext
« on: August 14, 2012, 04:16:56 PM »
Code: [Select]
        #region "Add prefix and suffix to the text or mtext multiply"
        [CommandMethod("PSUF")]
        public static void UpdateMultipleTexts()
        {

            Database db = HostApplicationServices.WorkingDatabase;

            Editor ed = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument.Editor;

            Transaction tr = db.TransactionManager.StartTransaction();

            string pref = GetstringDflt(ed, "Enter a Prefix: ", "A-");

            string suff = GetstringDflt(ed, "Enter a Suffix: ", "-B");

            using (tr)
            {

                try
                {
                    Entity ent;

                    PromptEntityResult per;

                    ObjectId id;

                    do
                    {
                        PromptEntityOptions peo = new PromptEntityOptions("\nSelect Text >>");
                        peo.SetRejectMessage("\nMust be selected a Text or Mtext only!");

                        peo.AddAllowedClass(typeof(DBText),false);

                        peo.AddAllowedClass(typeof(MText),false);

                        per = ed.GetEntity(peo);

                        if (per.Status != PromptStatus.OK)
                        {
                            break;
                        }
                        id = per.ObjectId;

                        ent = id.GetObject(OpenMode.ForRead) as Entity;

                        ed.WriteMessage("\nObject Selected:\t{0}", ent.GetRXClass().DxfName);

                        if ((!(ent is DBText)) && (!(ent is MText)))
                        {
                            ed.WriteMessage("\nNot a Text or MText");
                            continue;
                        }
                        DBText txt= ent as DBText;
                        if (txt!= null)
                        {
                            txt.UpgradeOpen();
                            string text = txt.TextString;
                            txt.TextString = pref + text+ suff;
                            txt.DowngradeOpen();
                        }

                        MText mtxt = ent as MText;
                        if (mtxt != null)
                        {
                            mtxt.UpgradeOpen();
                            string text = mtxt.Contents;
                            mtxt.Contents = pref + text + suff;
                            mtxt.DowngradeOpen();
                        }
                     
                        db.TransactionManager.QueueForGraphicsFlush();
                    }
                    while (per.Status == PromptStatus.OK);
                    tr.Commit();
                }

                catch (Autodesk.AutoCAD.Runtime.Exception ex)
                {

                    ed.WriteMessage("\n" + ex.StackTrace + "\n" + ex.Message);
                }

            }
        }
        #region "Helpers"
        public static string GetstringDflt(Editor ed, string msg, string dflt)
        {
            string answer = string.Empty;

            PromptStringOptions pso = new PromptStringOptions("\n" + msg);

            if (dflt != string.Empty)
            {
                pso.DefaultValue = dflt;
            }
            pso.AllowSpaces = true;

            PromptResult pr = ed.GetString(pso);

            if (pr.Status == PromptStatus.OK)
            {
                answer = pr.StringResult;
            }
            return answer;
        }
        #endregion

        #endregion

~'J'~